{-# LANGUAGE OverloadedStrings #-}
module Language.Faustus.Examples.MultiSig where

-- import           Language.Faustus
-- import           Language.Marlowe (Bound(..), TransactionInput(..), Input(..))
-- import qualified Language.Marlowe as M
-- import qualified Data.Text as T
-- import Data.Text.Encoding (encodeUtf8)

-- {- What does the vanilla contract look like?
--    Using layout for scoping here

-- When
--   bobClaims
--     when
--       carolAgrees
--         Pay "alice" "bob" price
--       carolDisagrees
--         Close "alice"
--   aliceClaims
--     when
--       carolAgrees
--         Close "alice"
--       carolDisagrees
--         Pay "alice" "bob" price

-- -}

-- partys :: [Party]
-- partys = map (PubKey . encodeUtf8 . T.pack . show) [0..4]

-- mPartys :: [M.Party]
-- mPartys = map (M.PubKey . encodeUtf8 . T.pack . show) [0..4]

-- sendChoiceName :: M.ChoiceName
-- sendChoiceName = "sendMoney"

-- addAllChoices :: Value
-- addAllChoices = AddValue (AddValue (AddValue (AddValue (ChoiceValue (ChoiceId sendChoiceName (UseParty "claimant1"))) (ChoiceValue (ChoiceId sendChoiceName (UseParty "claimant2")))) (ChoiceValue (ChoiceId sendChoiceName (UseParty "claimant3")))) (ChoiceValue (ChoiceId sendChoiceName (UseParty "claimant4")))) (ChoiceValue (ChoiceId sendChoiceName (UseParty "claimant5")))

-- defineProcessFifthChoice :: Contract -> Contract
-- defineProcessFifthChoice = LetC (Identifier "processChoiceMade5") [PartyParameter "claimant1", PartyParameter "claimant2", PartyParameter "claimant3", PartyParameter "claimant4", PartyParameter "claimant5"]
--   (If (ValueGE addAllChoices (Constant 3)) (Pay "alice" (Party "bob") M.ada price Close) Close)

-- defineProcessFourthChoice :: Contract -> Contract
-- defineProcessFourthChoice = LetC (Identifier "processChoiceMade4") [PartyParameter "claimant1", PartyParameter "claimant2", PartyParameter "claimant3", PartyParameter "claimant4", PartyParameter "nonclaimant1"]
--   (When 
--     [Case (makesClaim (UseParty "nonclaimant1")) (UseC "processChoiceMade5" [PartyArgument . UseParty $ "claimant1", PartyArgument . UseParty $ "claimant2", PartyArgument . UseParty $ "claimant3", PartyArgument . UseParty $ "claimant4", PartyArgument . UseParty $ "nonclaimant1"])] 100 Close)

-- defineProcessThirdChoice :: Contract -> Contract
-- defineProcessThirdChoice = LetC (Identifier "processChoiceMade3") [PartyParameter "claimant1", PartyParameter "claimant2", PartyParameter "claimant3", PartyParameter "nonclaimant1", PartyParameter "nonclaimant2"]
--   (When 
--     [Case (makesClaim (UseParty "nonclaimant1")) (UseC "processChoiceMade4" [PartyArgument . UseParty $ "claimant1", PartyArgument . UseParty $ "claimant2", PartyArgument . UseParty $ "claimant3", PartyArgument . UseParty $ "nonclaimant1", PartyArgument . UseParty $ "nonclaimant2"])
--     , Case (makesClaim (UseParty "nonclaimant2")) (UseC "processChoiceMade4" [PartyArgument . UseParty $ "claimant1", PartyArgument . UseParty $ "claimant2", PartyArgument . UseParty $ "claimant3", PartyArgument . UseParty $ "nonclaimant2", PartyArgument . UseParty $ "nonclaimant1"])] 100 Close)

-- defineProcessSecondChoice :: Contract -> Contract
-- defineProcessSecondChoice = LetC (Identifier "processChoiceMade2") [PartyParameter "claimant1", PartyParameter "claimant2", PartyParameter "nonclaimant1", PartyParameter "nonclaimant2", PartyParameter "nonclaimant3"]
--   (When 
--     [Case (makesClaim (UseParty "nonclaimant1")) (UseC "processChoiceMade3" [PartyArgument . UseParty $ "claimant1", PartyArgument . UseParty $ "claimant2", PartyArgument . UseParty $ "nonclaimant1", PartyArgument . UseParty $ "nonclaimant2", PartyArgument . UseParty $ "nonclaimant3"])
--     , Case (makesClaim (UseParty "nonclaimant2")) (UseC "processChoiceMade3" [PartyArgument . UseParty $ "claimant1", PartyArgument . UseParty $ "claimant2", PartyArgument . UseParty $ "nonclaimant2", PartyArgument . UseParty $ "nonclaimant1", PartyArgument . UseParty $ "nonclaimant3"])
--     , Case (makesClaim (UseParty "nonclaimant3")) (UseC "processChoiceMade3" [PartyArgument . UseParty $ "claimant1", PartyArgument . UseParty $ "claimant2", PartyArgument . UseParty $ "nonclaimant3", PartyArgument . UseParty $ "nonclaimant1", PartyArgument . UseParty $ "nonclaimant2"])] 100 Close)

-- defineProcessFirstChoice :: Contract -> Contract
-- defineProcessFirstChoice = LetC (Identifier "processChoiceMade1") [PartyParameter "claimant1", PartyParameter "nonclaimant1", PartyParameter "nonclaimant2", PartyParameter "nonclaimant3", PartyParameter "nonclaimant4"]
--   (When 
--     [Case (makesClaim (UseParty "nonclaimant1")) (UseC "processChoiceMade2" [PartyArgument . UseParty $ "claimant1", PartyArgument . UseParty $ "nonclaimant1", PartyArgument . UseParty $ "nonclaimant2", PartyArgument . UseParty $ "nonclaimant3", PartyArgument . UseParty $ "nonclaimant4"])
--     , Case (makesClaim (UseParty "nonclaimant2")) (UseC "processChoiceMade2" [PartyArgument . UseParty $ "claimant1", PartyArgument . UseParty $ "nonclaimant2", PartyArgument . UseParty $ "nonclaimant1", PartyArgument . UseParty $ "nonclaimant3", PartyArgument . UseParty $ "nonclaimant4"])
--     , Case (makesClaim (UseParty "nonclaimant3")) (UseC "processChoiceMade2" [PartyArgument . UseParty $ "claimant1", PartyArgument . UseParty $ "nonclaimant3", PartyArgument . UseParty $ "nonclaimant1", PartyArgument . UseParty $ "nonclaimant2", PartyArgument . UseParty $ "nonclaimant4"])
--     , Case (makesClaim (UseParty "nonclaimant4")) (UseC "processChoiceMade2" [PartyArgument . UseParty $ "claimant1", PartyArgument . UseParty $ "nonclaimant4", PartyArgument . UseParty $ "nonclaimant1", PartyArgument . UseParty $ "nonclaimant2", PartyArgument . UseParty $ "nonclaimant3"])] 100 Close)

-- contract :: Contract
-- contract = defineProcessFifthChoice . defineProcessFourthChoice . defineProcessThirdChoice . defineProcessSecondChoice . defineProcessFirstChoice $ When [Case (Deposit "alice" "alice" M.ada price) 
--                       (When 
--                         [Case (makesClaim $ partys !! 0) (UseC "processChoiceMade1" [PartyArgument $ partys !! 0, PartyArgument $ partys !! 1, PartyArgument $ partys !! 2, PartyArgument $ partys !! 3, PartyArgument $ partys !! 4])
--                         , Case (makesClaim $ partys !! 1) (UseC "processChoiceMade1" [PartyArgument $ partys !! 1, PartyArgument $ partys !! 0, PartyArgument $ partys !! 2, PartyArgument $ partys !! 3, PartyArgument $ partys !! 4])
--                         , Case (makesClaim $ partys !! 2) (UseC "processChoiceMade1" [PartyArgument $ partys !! 2, PartyArgument $ partys !! 0, PartyArgument $ partys !! 1, PartyArgument $ partys !! 3, PartyArgument $ partys !! 4])
--                         , Case (makesClaim $ partys !! 3) (UseC "processChoiceMade1" [PartyArgument $ partys !! 3, PartyArgument $ partys !! 0, PartyArgument $ partys !! 1, PartyArgument $ partys !! 2, PartyArgument $ partys !! 4])
--                         , Case (makesClaim $ partys !! 4) (UseC "processChoiceMade1" [PartyArgument $ partys !! 4, PartyArgument $ partys !! 0, PartyArgument $ partys !! 1, PartyArgument $ partys !! 2, PartyArgument $ partys !! 3])] 100 Close)
--                 ]
--                 10
--                 Close

-- makesClaim :: Party -> Action
-- makesClaim p = Choice (ChoiceId sendChoiceName p) [Bound 0 1]


-- -- Value under escrow
-- price :: Value
-- price = Constant 450

-- runSendToBobClaims = playTrace 0 contract [inputs]
--   where inputs = TransactionInput {txInterval = M.TimeInterval 0 0, txInputs = map M.NormalInput [M.IDeposit "alice" "alice" M.ada 450,
--                                                                                 M.IChoice (M.ChoiceId sendChoiceName (mPartys !! 0)) 1,
--                                                                                 M.IChoice (M.ChoiceId sendChoiceName (mPartys !! 1)) 0,
--                                                                                 M.IChoice (M.ChoiceId sendChoiceName (mPartys !! 2)) 1,
--                                                                                 M.IChoice (M.ChoiceId sendChoiceName (mPartys !! 3)) 0,
--                                                                                 M.IChoice (M.ChoiceId sendChoiceName (mPartys !! 4)) 1]}
                                                                                
-- runSendToAliceClaims = playTrace 0 contract [inputs]
--   where inputs = TransactionInput {txInterval = M.TimeInterval 0 0, txInputs = map M.NormalInput [M.IDeposit "alice" "alice" M.ada 450,
--                                                                                 M.IChoice (M.ChoiceId sendChoiceName (mPartys !! 0)) 0,
--                                                                                 M.IChoice (M.ChoiceId sendChoiceName (mPartys !! 1)) 1,
--                                                                                 M.IChoice (M.ChoiceId sendChoiceName (mPartys !! 2)) 0,
--                                                                                 M.IChoice (M.ChoiceId sendChoiceName (mPartys !! 3)) 1,
--                                                                                 M.IChoice (M.ChoiceId sendChoiceName (mPartys !! 4)) 0]}

-- {-
-- LetC "processChoiceMade5" [(PartyParameter "claimant1"), (PartyParameter "claimant2"), (PartyParameter "claimant3"), (PartyParameter "claimant4"), (PartyParameter "claimant5")]
--   (If
--      (ValueGE
--         (AddValue
--            (AddValue
--               (AddValue
--                  (AddValue
--                     (ChoiceValue
--                        (ChoiceId "sendMoney" (UseParty "claimant1")))
--                     (ChoiceValue
--                        (ChoiceId "sendMoney" (UseParty "claimant2"))))
--                  (ChoiceValue
--                     (ChoiceId "sendMoney" (UseParty "claimant3"))))
--               (ChoiceValue
--                  (ChoiceId "sendMoney" (UseParty "claimant4"))))
--            (ChoiceValue
--               (ChoiceId "sendMoney" (UseParty "claimant5"))))
--         (Constant 3))
--      (Pay (ConstantPubKey "alice")
--         (Party (ConstantPubKey "bob"))
--         (Constant 450) Close) Close)
--   (LetC "processChoiceMade4" [(PartyParameter "claimant1"), (PartyParameter "claimant2"), (PartyParameter "claimant3"), (PartyParameter "claimant4"), (PartyParameter "nonclaimant1")]
--      (When [
--         (Case
--            (Choice
--               (ChoiceId "sendMoney" (UseParty "nonclaimant1")) [
--               (Bound 0 1)])
--            (UseC "processChoiceMade5" [(PartyArgument(UseParty "claimant1")),(PartyArgument(UseParty "claimant2")),(PartyArgument(UseParty "claimant3")),(PartyArgument(UseParty "claimant4")),(PartyArgument(UseParty "nonclaimant1"))]))] 100 Close)
--      (LetC "processChoiceMade3" [(PartyParameter "claimant1"),(PartyParameter "claimant2"),(PartyParameter "claimant3"),(PartyParameter "nonclaimant1"),(PartyParameter "nonclaimant2")]
--         (When [
--               (Case
--                  (Choice
--                     (ChoiceId "sendMoney" (UseParty "nonclaimant1")) [
--                     (Bound 0 1)])
--                  (UseC "processChoiceMade4" [(PartyArgument(UseParty "claimant1")),(PartyArgument(UseParty "claimant2")),(PartyArgument(UseParty "claimant3")),(PartyArgument(UseParty "nonclaimant1")),(PartyArgument(UseParty "nonclaimant2"))]))
--               ,
--               (Case
--                  (Choice
--                     (ChoiceId "sendMoney" (UseParty "nonclaimant2")) [
--                     (Bound 0 1)])
--                  (UseC "processChoiceMade4" [(PartyArgument(UseParty "claimant1")),(PartyArgument(UseParty "claimant2")),(PartyArgument(UseParty "claimant3")),(PartyArgument(UseParty "nonclaimant2")),(PartyArgument(UseParty "nonclaimant1"))]))] 100 Close)
--         (LetC "processChoiceMade2" [(PartyParameter "claimant1"),(PartyParameter "claimant2"),(PartyParameter "nonclaimant1"),(PartyParameter "nonclaimant2"),(PartyParameter "nonclaimant3")]
--            (When [
--                  (Case
--                     (Choice
--                        (ChoiceId "sendMoney" (UseParty "nonclaimant1")) [
--                        (Bound 0 1)])
--                     (UseC "processChoiceMade3" [(PartyArgument(UseParty "claimant1")),(PartyArgument(UseParty "claimant2")),(PartyArgument(UseParty "nonclaimant1")),(PartyArgument(UseParty "nonclaimant2")),(PartyArgument(UseParty "nonclaimant3"))]))
--                  ,
--                  (Case
--                     (Choice
--                        (ChoiceId "sendMoney"(UseParty "nonclaimant2")) [
--                        (Bound 0 1)])
--                     (UseC "processChoiceMade3" [(PartyArgument(UseParty "claimant1")),(PartyArgument(UseParty "claimant2")),(PartyArgument(UseParty "nonclaimant2")),(PartyArgument(UseParty "nonclaimant1")),(PartyArgument(UseParty "nonclaimant3"))]))
--                  ,
--                  (Case
--                     (Choice
--                        (ChoiceId "sendMoney"(UseParty "nonclaimant3")) [
--                        (Bound 0 1)])
--                     (UseC "processChoiceMade3" [(PartyArgument(UseParty "claimant1")),(PartyArgument(UseParty "claimant2")),(PartyArgument(UseParty "nonclaimant3")),
--                                                (PartyArgument(UseParty "nonclaimant1")),(PartyArgument(UseParty "nonclaimant2"))]))] 100 Close)
--            (LetC "processChoiceMade1" [(PartyParameter "claimant1"),(PartyParameter "nonclaimant1"),(PartyParameter "nonclaimant2"),(PartyParameter "nonclaimant3"),(PartyParameter "nonclaimant4")]
--               (When [
--                     (Case
--                        (Choice
--                           (ChoiceId "sendMoney"(UseParty "nonclaimant1")) [
--                           (Bound 0 1)])
--                        (UseC "processChoiceMade2" [(PartyArgument(UseParty "claimant1")),(PartyArgument(UseParty "nonclaimant1")),(PartyArgument(UseParty "nonclaimant2")),(PartyArgument(UseParty "nonclaimant3")),(PartyArgument(UseParty "nonclaimant4"))]))
--                     ,
--                     (Case
--                        (Choice
--                           (ChoiceId "sendMoney"(UseParty "nonclaimant2")) [
--                           (Bound 0 1)])
--                        (UseC "processChoiceMade2" [(PartyArgument(UseParty "claimant1")),(PartyArgument(UseParty "nonclaimant2")),(PartyArgument(UseParty "nonclaimant1")),(PartyArgument(UseParty "nonclaimant3")),(PartyArgument(UseParty "nonclaimant4"))]))
--                     ,
--                     (Case
--                        (Choice
--                           (ChoiceId "sendMoney"(UseParty "nonclaimant3")) [
--                           (Bound 0 1)])
--                        (UseC "processChoiceMade2" [(PartyArgument(UseParty "claimant1")),(PartyArgument(UseParty "nonclaimant3")),(PartyArgument(UseParty "nonclaimant1")),(PartyArgument(UseParty "nonclaimant2")),(PartyArgument(UseParty "nonclaimant4"))]))
--                     ,
--                     (Case
--                        (Choice
--                           (ChoiceId "sendMoney"(UseParty "nonclaimant4")) [
--                           (Bound 0 1)])
--                        (UseC "processChoiceMade2" [(PartyArgument(UseParty "claimant1")),(PartyArgument(UseParty "nonclaimant4")),(PartyArgument(UseParty "nonclaimant1")),(PartyArgument(UseParty "nonclaimant2")),(PartyArgument(UseParty "nonclaimant3"))]))] 100 Close)
--               (When [
--                  (Case
--                     (Deposit(ConstantPubKey "alice")(ConstantPubKey "alice")(Constant 450))
--                     (When [
--                           (Case
--                              (Choice
--                                 (ChoiceId "sendMoney"(ConstantPubKey "0")) [
--                                 (Bound 0 1)])
--                              (UseC "processChoiceMade1" [(PartyArgument(ConstantPubKey "0")),(PartyArgument(ConstantPubKey "1")),(PartyArgument(ConstantPubKey "2")),(PartyArgument(ConstantPubKey "3")),(PartyArgument(ConstantPubKey "4"))]))
--                           ,
--                           (Case
--                              (Choice
--                                 (ChoiceId "sendMoney"(ConstantPubKey "1")) [
--                                 (Bound 0 1)])
--                              (UseC "processChoiceMade1" [(PartyArgument(ConstantPubKey "1")),(PartyArgument(ConstantPubKey "0")),(PartyArgument(ConstantPubKey "2")),(PartyArgument(ConstantPubKey "3")),(PartyArgument(ConstantPubKey "4"))]))
--                           ,
--                           (Case
--                              (Choice
--                                 (ChoiceId "sendMoney"(ConstantPubKey "2")) [
--                                 (Bound 0 1)])
--                              (UseC "processChoiceMade1" [(PartyArgument(ConstantPubKey "2")),(PartyArgument(ConstantPubKey "0")),(PartyArgument(ConstantPubKey "1")),(PartyArgument(ConstantPubKey "3")),(PartyArgument(ConstantPubKey "4"))]))
--                           ,
--                           (Case
--                              (Choice
--                                 (ChoiceId "sendMoney"(ConstantPubKey "3")) [
--                                 (Bound 0 1)])
--                              (UseC "processChoiceMade1" [(PartyArgument(ConstantPubKey "3")),(PartyArgument(ConstantPubKey "0")),(PartyArgument(ConstantPubKey "1")),(PartyArgument(ConstantPubKey "2")),(PartyArgument(ConstantPubKey "4"))]))
--                           ,
--                           (Case
--                              (Choice
--                                 (ChoiceId "sendMoney"(ConstantPubKey "4")) [
--                                 (Bound 0 1)])
--                              (UseC "processChoiceMade1" [(PartyArgument(ConstantPubKey "4")),(PartyArgument(ConstantPubKey "0")),(PartyArgument(ConstantPubKey "1")),(PartyArgument(ConstantPubKey "2")),(PartyArgument(ConstantPubKey "3"))]))] 100 Close))] 10 Close)))))
--  -}